import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["sx"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import React, { useMemo } from "react";
import { jsx, useTheme } from "@emotion/react";
import getCss from "./css";

var isEmpty = function isEmpty(obj) {
  return Object.keys(obj).length === 0;
};

function createComponent(component) {
  function Component(_ref, ref) {
    var _ref$sx = _ref.sx,
        sx = _ref$sx === void 0 ? {} : _ref$sx,
        props = _objectWithoutProperties(_ref, _excluded);

    var theme = useTheme();
    var css = useMemo(function () {
      return getCss(sx, theme);
    }, [sx, theme]);
    var hasCss = !isEmpty(css);
    return jsx(component, _objectSpread(_objectSpread({
      ref: ref
    }, props), hasCss && {
      css: css
    }));
  }

  return /*#__PURE__*/React.forwardRef(Component);
}

export default createComponent;